﻿Imports System.IO

Public Class Form1
  Dim WithEvents serialPort As New IO.Ports.SerialPort
  Dim header As String
  Dim mfrID, model, unit As Integer
  Dim Version As String = "0.0.1"

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim i As Integer

    Me.Text = Me.Text & " ver. " & Version

    For i = 0 To My.Computer.Ports.SerialPortNames.Count - 1   ' enumerate ports discovered, stuff combo box
      cbbCOMPorts.Items.Add(My.Computer.Ports.SerialPortNames(i))
    Next
    cbbCOMPorts.SelectedIndex = 0

    read_a0_file()

    lblQval.Text = Format(tbFiltQ.Value / 10.0, "##.0")

    Dim s As Object = 0
    Dim e_tmp As EventArgs = Nothing
    btnSequential_Click(s, e_tmp)
    btnReciprocals_Click(s, e_tmp)

    mfrID = &H7F : model = &HA : unit = &H0  ' my mfr is 7F (just because), model # is zero and unit number is zero.
    '''''''''''''''''''''''''''''''''''''' 
    header = Chr(&HF0) + Chr(mfrID) + Chr(model) + Chr(unit)   ' sysexe header
  End Sub

  Sub read_a0_file()
    Dim v As Integer
    Dim reader As StreamReader
    reader = New StreamReader("a0.txt")
    v = Val(reader.ReadLine()) : tb_a0_0_310.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_311.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_312.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_313.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_314.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_315.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_316.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_317.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_318.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_319.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3110.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3111.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3112.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3113.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3114.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3115.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3116.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3117.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3118.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3119.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3120.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3121.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3122.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3123.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3124.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3125.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3126.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3127.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3128.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3129.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3130.Value = v
    v = Val(reader.ReadLine()) : tb_a0_0_3131.Value = v

    v = Val(reader.ReadLine()) : tb_a0_32_630.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_631.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_632.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_633.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_634.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_635.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_636.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_637.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_638.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_639.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6310.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6311.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6312.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6313.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6314.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6315.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6316.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6317.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6318.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6319.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6320.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6321.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6322.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6323.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6324.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6325.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6326.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6327.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6328.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6329.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6330.Value = v
    v = Val(reader.ReadLine()) : tb_a0_32_6331.Value = v

    tb_a0_0_310_Scroll(Nothing, Nothing)
    tb_a0_0_311_Scroll(Nothing, Nothing)
    tb_a0_0_312_Scroll(Nothing, Nothing)
    tb_a0_0_313_Scroll(Nothing, Nothing)
    tb_a0_0_314_Scroll(Nothing, Nothing)
    tb_a0_0_315_Scroll(Nothing, Nothing)
    tb_a0_0_316_Scroll(Nothing, Nothing)
    tb_a0_0_317_Scroll(Nothing, Nothing)
    tb_a0_0_318_Scroll(Nothing, Nothing)
    tb_a0_0_319_Scroll(Nothing, Nothing)
    tb_a0_0_3110_Scroll(Nothing, Nothing)
    tb_a0_0_3111_Scroll(Nothing, Nothing)
    tb_a0_0_3112_Scroll(Nothing, Nothing)
    tb_a0_0_3113_Scroll(Nothing, Nothing)
    tb_a0_0_3114_Scroll(Nothing, Nothing)
    tb_a0_0_3115_Scroll(Nothing, Nothing)
    tb_a0_0_3116_Scroll(Nothing, Nothing)
    tb_a0_0_3117_Scroll(Nothing, Nothing)
    tb_a0_0_3118_Scroll(Nothing, Nothing)
    tb_a0_0_3119_Scroll(Nothing, Nothing)
    tb_a0_0_3120_Scroll(Nothing, Nothing)
    tb_a0_0_3121_Scroll(Nothing, Nothing)
    tb_a0_0_3122_Scroll(Nothing, Nothing)
    tb_a0_0_3123_Scroll(Nothing, Nothing)
    tb_a0_0_3124_Scroll(Nothing, Nothing)
    tb_a0_0_3125_Scroll(Nothing, Nothing)
    tb_a0_0_3126_Scroll(Nothing, Nothing)
    tb_a0_0_3127_Scroll(Nothing, Nothing)
    tb_a0_0_3128_Scroll(Nothing, Nothing)
    tb_a0_0_3129_Scroll(Nothing, Nothing)
    tb_a0_0_3130_Scroll(Nothing, Nothing)
    tb_a0_0_3131_Scroll(Nothing, Nothing)

    tb_a0_32_630_Scroll(Nothing, Nothing)
    tb_a0_32_631_Scroll(Nothing, Nothing)
    tb_a0_32_632_Scroll(Nothing, Nothing)
    tb_a0_32_633_Scroll(Nothing, Nothing)
    tb_a0_32_634_Scroll(Nothing, Nothing)
    tb_a0_32_635_Scroll(Nothing, Nothing)
    tb_a0_32_636_Scroll(Nothing, Nothing)
    tb_a0_32_637_Scroll(Nothing, Nothing)
    tb_a0_32_638_Scroll(Nothing, Nothing)
    tb_a0_32_639_Scroll(Nothing, Nothing)
    tb_a0_32_6310_Scroll(Nothing, Nothing)
    tb_a0_32_6311_Scroll(Nothing, Nothing)
    tb_a0_32_6312_Scroll(Nothing, Nothing)
    tb_a0_32_6313_Scroll(Nothing, Nothing)
    tb_a0_32_6314_Scroll(Nothing, Nothing)
    tb_a0_32_6315_Scroll(Nothing, Nothing)
    tb_a0_32_6316_Scroll(Nothing, Nothing)
    tb_a0_32_6317_Scroll(Nothing, Nothing)
    tb_a0_32_6318_Scroll(Nothing, Nothing)
    tb_a0_32_6319_Scroll(Nothing, Nothing)
    tb_a0_32_6320_Scroll(Nothing, Nothing)
    tb_a0_32_6321_Scroll(Nothing, Nothing)
    tb_a0_32_6322_Scroll(Nothing, Nothing)
    tb_a0_32_6323_Scroll(Nothing, Nothing)
    tb_a0_32_6324_Scroll(Nothing, Nothing)
    tb_a0_32_6325_Scroll(Nothing, Nothing)
    tb_a0_32_6326_Scroll(Nothing, Nothing)
    tb_a0_32_6327_Scroll(Nothing, Nothing)
    tb_a0_32_6328_Scroll(Nothing, Nothing)
    tb_a0_32_6329_Scroll(Nothing, Nothing)
    tb_a0_32_6330_Scroll(Nothing, Nothing)
    tb_a0_32_6331_Scroll(Nothing, Nothing)

    reader.Close()

  End Sub

  ' handler for Send button clicks
  Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
    Try
      btnUpdate.BackColor = Color.Red
      btnUpdate.Enabled = False
      btnUpdate.Refresh()
      SendPatch()
      btnUpdate.BackColor = Color.Lime
      btnUpdate.Enabled = True
      btnUpdate.Refresh()
    Catch ex As Exception
      MsgBox("ERROR" & vbCrLf & ex.ToString)
    End Try
  End Sub
  Private Sub Disconnect()
    Try
      serialPort.Close()
    Catch ex As Exception
      MsgBox(ex.ToString)
    End Try
  End Sub
  Private Sub Connect()
    If serialPort.IsOpen Then
      serialPort.Close()
    End If
    Try
      With serialPort
        .PortName = cbbCOMPorts.Text
        .BaudRate = 19200
        .Parity = IO.Ports.Parity.None
        .DataBits = 8
        .StopBits = IO.Ports.StopBits.One
        '            .Encoding = System.Text.Encoding.Unicode
        .Encoding = System.Text.Encoding.Default          ' default is unmodified, 8 bit
      End With
      serialPort.Open()

    Catch ex As Exception
      MsgBox(ex.ToString)
    End Try

  End Sub

  Private Sub tb_a0_0_310_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_310.Scroll
    lblLev0.Text = Format(tb_a0_0_310.Value / 131072.0, "0.00000")
  End Sub
  Private Sub tb_a0_0_311_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_311.Scroll
    lblLev1.Text = Format(tb_a0_0_311.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_312_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_312.Scroll
    lblLev2.Text = Format(tb_a0_0_312.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_313_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_313.Scroll
    lblLev3.Text = Format(tb_a0_0_313.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_314_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_314.Scroll
    lblLev4.Text = Format(tb_a0_0_314.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_315_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_315.Scroll
    lblLev5.Text = Format(tb_a0_0_315.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_316_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_316.Scroll
    lblLev6.Text = Format(tb_a0_0_316.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_317_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_317.Scroll
    lblLev7.Text = Format(tb_a0_0_317.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_318_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_318.Scroll
    lblLev8.Text = Format(tb_a0_0_318.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_319_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_319.Scroll
    lblLev9.Text = Format(tb_a0_0_319.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3110_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3110.Scroll
    lblLev10.Text = Format(tb_a0_0_3110.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3111_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3111.Scroll
    lblLev11.Text = Format(tb_a0_0_3111.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3112_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3112.Scroll
    lblLev12.Text = Format(tb_a0_0_3112.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3113_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3113.Scroll
    lblLev13.Text = Format(tb_a0_0_3113.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3114_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3114.Scroll
    lblLev14.Text = Format(tb_a0_0_3114.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3115_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3115.Scroll
    lblLev15.Text = Format(tb_a0_0_3115.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3116_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3116.Scroll
    lblLev16.Text = Format(tb_a0_0_3116.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3117_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3117.Scroll
    lblLev17.Text = Format(tb_a0_0_3117.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3118_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3118.Scroll
    lblLev18.Text = Format(tb_a0_0_3118.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3119_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3119.Scroll
    lblLev19.Text = Format(tb_a0_0_3119.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3120_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3120.Scroll
    lblLev20.Text = Format(tb_a0_0_3120.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3121_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3121.Scroll
    lblLev21.Text = Format(tb_a0_0_3121.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3122_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3122.Scroll
    lblLev22.Text = Format(tb_a0_0_3122.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3123_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3123.Scroll
    lblLev23.Text = Format(tb_a0_0_3123.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3124_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3124.Scroll
    lblLev24.Text = Format(tb_a0_0_3124.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3125_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3125.Scroll
    lblLev25.Text = Format(tb_a0_0_3125.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3126_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3126.Scroll
    lblLev26.Text = Format(tb_a0_0_3126.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3127_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3127.Scroll
    lblLev27.Text = Format(tb_a0_0_3127.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3128_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3128.Scroll
    lblLev28.Text = Format(tb_a0_0_3128.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3129_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3129.Scroll
    lblLev29.Text = Format(tb_a0_0_3129.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3130_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3130.Scroll
    lblLev30.Text = Format(tb_a0_0_3130.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_0_3131_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_0_3131.Scroll
    lblLev31.Text = Format(tb_a0_0_3131.Value / 131072.0, "0.00000#")
  End Sub

  '==================================================================================================================

  Private Sub tb_a0_32_630_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_630.Scroll
    lblNoiseMod0.Text = Format(tb_a0_32_630.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_631_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_631.Scroll
    lblNoiseMod1.Text = Format(tb_a0_32_631.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_632_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_632.Scroll
    lblNoiseMod2.Text = Format(tb_a0_32_632.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_633_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_633.Scroll
    lblNoiseMod3.Text = Format(tb_a0_32_633.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_634_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_634.Scroll
    lblNoiseMod4.Text = Format(tb_a0_32_634.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_635_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_635.Scroll
    lblNoiseMod5.Text = Format(tb_a0_32_635.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_636_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_636.Scroll
    lblNoiseMod6.Text = Format(tb_a0_32_636.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_637_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_637.Scroll
    lblNoiseMod7.Text = Format(tb_a0_32_637.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_638_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_638.Scroll
    lblNoiseMod8.Text = Format(tb_a0_32_638.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_639_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_639.Scroll
    lblNoiseMod9.Text = Format(tb_a0_32_639.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6310_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6310.Scroll
    lblNoiseMod10.Text = tb_a0_32_6310.Value.ToString()
    lblNoiseMod10.Text = Format(tb_a0_32_6310.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6311_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6311.Scroll
    lblNoiseMod11.Text = Format(tb_a0_32_6311.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6312_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6312.Scroll
    lblNoiseMod12.Text = Format(tb_a0_32_6312.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6313_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6313.Scroll
    lblNoiseMod13.Text = Format(tb_a0_32_6313.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6314_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6314.Scroll
    lblNoiseMod14.Text = Format(tb_a0_32_6314.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6315_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6315.Scroll
    lblNoiseMod15.Text = Format(tb_a0_32_6315.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6316_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6316.Scroll
    lblNoiseMod16.Text = Format(tb_a0_32_6316.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6317_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6317.Scroll
    lblNoiseMod17.Text = Format(tb_a0_32_6317.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6318_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6318.Scroll
    lblNoiseMod18.Text = Format(tb_a0_32_6318.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6319_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6319.Scroll
    lblNoiseMod19.Text = Format(tb_a0_32_6319.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6320_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6320.Scroll
    lblNoiseMod20.Text = Format(tb_a0_32_6320.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6321_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6321.Scroll
    lblNoiseMod21.Text = Format(tb_a0_32_6321.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6322_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6322.Scroll
    lblNoiseMod22.Text = Format(tb_a0_32_6322.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6323_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6323.Scroll
    lblNoiseMod23.Text = Format(tb_a0_32_6323.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6324_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6324.Scroll
    lblNoiseMod24.Text = Format(tb_a0_32_6324.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6325_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6325.Scroll
    lblNoiseMod25.Text = Format(tb_a0_32_6325.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6326_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6326.Scroll
    lblNoiseMod26.Text = Format(tb_a0_32_6326.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6327_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6327.Scroll
    lblNoiseMod27.Text = Format(tb_a0_32_6327.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6328_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6328.Scroll
    lblNoiseMod28.Text = Format(tb_a0_32_6328.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6329_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6329.Scroll
    lblNoiseMod29.Text = Format(tb_a0_32_6329.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6330_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6330.Scroll
    lblNoiseMod30.Text = Format(tb_a0_32_6330.Value / 131072.0, "0.00000#")
  End Sub
  Private Sub tb_a0_32_6331_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_a0_32_6331.Scroll
    lblNoiseMod31.Text = Format(tb_a0_32_6331.Value / 131072.0, "0.00000#")
  End Sub

  '==================================================================================================================

  Private Sub tbPortTime0_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime0.Scroll
    lblPortTime0.Text = tbPortTime0.Value.ToString()
  End Sub
  Private Sub tbPortTime1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime1.Scroll
    lblPortTime1.Text = tbPortTime1.Value.ToString()
  End Sub
  Private Sub tbPortTime2_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime2.Scroll
    lblPortTime2.Text = tbPortTime2.Value.ToString()
  End Sub
  Private Sub tbPortTime3_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime3.Scroll
    lblPortTime3.Text = tbPortTime3.Value.ToString()
  End Sub
  Private Sub tbPortTime4_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime4.Scroll
    lblPortTime4.Text = tbPortTime4.Value.ToString()
  End Sub
  Private Sub tbPortTime5_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime5.Scroll
    lblPortTime5.Text = tbPortTime5.Value.ToString()
  End Sub
  Private Sub tbPortTime6_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime6.Scroll
    lblPortTime6.Text = tbPortTime6.Value.ToString()
  End Sub
  Private Sub tbPortTime7_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime7.Scroll
    lblPortTime7.Text = tbPortTime7.Value.ToString()
  End Sub
  Private Sub tbPortTime8_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime8.Scroll
    lblPortTime8.Text = tbPortTime8.Value.ToString()
  End Sub
  Private Sub tbPortTime9_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime9.Scroll
    lblPortTime9.Text = tbPortTime9.Value.ToString()
  End Sub
  Private Sub tbPortTime10_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime10.Scroll
    lblPortTime10.Text = tbPortTime10.Value.ToString()
  End Sub
  Private Sub tbPortTime11_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime11.Scroll
    lblPortTime11.Text = tbPortTime11.Value.ToString()
  End Sub
  Private Sub tbPortTime12_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime12.Scroll
    lblPortTime12.Text = tbPortTime12.Value.ToString()
  End Sub
  Private Sub tbPortTime13_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime13.Scroll
    lblPortTime13.Text = tbPortTime13.Value.ToString()
  End Sub
  Private Sub tbPortTime14_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime14.Scroll
    lblPortTime14.Text = tbPortTime14.Value.ToString()
  End Sub
  Private Sub tbPortTime15_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime15.Scroll
    lblPortTime15.Text = tbPortTime15.Value.ToString()
  End Sub
  Private Sub tbPortTime16_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime16.Scroll
    lblPortTime16.Text = tbPortTime16.Value.ToString()
  End Sub
  Private Sub tbPortTime17_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime17.Scroll
    lblPortTime17.Text = tbPortTime17.Value.ToString()
  End Sub
  Private Sub tbPortTime18_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime18.Scroll
    lblPortTime18.Text = tbPortTime18.Value.ToString()
  End Sub
  Private Sub tbPortTime19_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime19.Scroll
    lblPortTime19.Text = tbPortTime19.Value.ToString()
  End Sub
  Private Sub tbPortTime20_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime20.Scroll
    lblPortTime20.Text = tbPortTime20.Value.ToString()
  End Sub
  Private Sub tbPortTime21_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime21.Scroll
    lblPortTime21.Text = tbPortTime21.Value.ToString()
  End Sub
  Private Sub tbPortTime22_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime22.Scroll
    lblPortTime22.Text = tbPortTime22.Value.ToString()
  End Sub
  Private Sub tbPortTime23_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime23.Scroll
    lblPortTime23.Text = tbPortTime23.Value.ToString()
  End Sub
  Private Sub tbPortTime24_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime24.Scroll
    lblPortTime24.Text = tbPortTime24.Value.ToString()
  End Sub
  Private Sub tbPortTime25_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime25.Scroll
    lblPortTime25.Text = tbPortTime25.Value.ToString()
  End Sub
  Private Sub tbPortTime26_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime26.Scroll
    lblPortTime26.Text = tbPortTime26.Value.ToString()
  End Sub
  Private Sub tbPortTime27_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime27.Scroll
    lblPortTime27.Text = tbPortTime27.Value.ToString()
  End Sub
  Private Sub tbPortTime28_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime28.Scroll
    lblPortTime28.Text = tbPortTime28.Value.ToString()
  End Sub
  Private Sub tbPortTime29_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime29.Scroll
    lblPortTime29.Text = tbPortTime29.Value.ToString()
  End Sub
  Private Sub tbPortTime30_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime30.Scroll
    lblPortTime30.Text = tbPortTime30.Value.ToString()
  End Sub
  Private Sub tbPortTime31_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPortTime31.Scroll
    lblPortTime31.Text = tbPortTime31.Value.ToString()
  End Sub


  '==================================================================================================================

  Private Sub tbFineTune0_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune0.Scroll
    lblFineTune0.Text = tbFineTune0.Value
  End Sub
  Private Sub tbFineTune1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune1.Scroll
    lblFineTune1.Text = tbFineTune1.Value
  End Sub
  Private Sub tbFineTune2_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune2.Scroll
    lblFineTune2.Text = tbFineTune2.Value
  End Sub
  Private Sub tbFineTune3_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune3.Scroll
    lblFineTune3.Text = tbFineTune3.Value
  End Sub
  Private Sub tbFineTune4_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune4.Scroll
    lblFineTune4.Text = tbFineTune4.Value
  End Sub
  Private Sub tbFineTune5_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune5.Scroll
    lblFineTune5.Text = tbFineTune5.Value
  End Sub
  Private Sub tbFineTune6_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune6.Scroll
    lblFineTune6.Text = tbFineTune6.Value
  End Sub
  Private Sub tbFineTune7_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune7.Scroll
    lblFineTune7.Text = tbFineTune7.Value
  End Sub
  Private Sub tbFineTune8_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune8.Scroll
    lblFineTune8.Text = tbFineTune8.Value
  End Sub
  Private Sub tbFineTune9_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune9.Scroll
    lblFineTune9.Text = tbFineTune9.Value
  End Sub
  Private Sub tbFineTune10_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune10.Scroll
    lblFineTune10.Text = tbFineTune10.Value
  End Sub
  Private Sub tbFineTune11_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune11.Scroll
    lblFineTune11.Text = tbFineTune11.Value
  End Sub
  Private Sub tbFineTune12_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune12.Scroll
    lblFineTune12.Text = tbFineTune12.Value
  End Sub
  Private Sub tbFineTune13_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune13.Scroll
    lblFineTune13.Text = tbFineTune13.Value
  End Sub
  Private Sub tbFineTune14_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune14.Scroll
    lblFineTune14.Text = tbFineTune14.Value
  End Sub
  Private Sub tbFineTune15_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune15.Scroll
    lblFineTune15.Text = tbFineTune15.Value
  End Sub
  Private Sub tbFineTune16_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune16.Scroll
    lblFineTune16.Text = tbFineTune16.Value
  End Sub
  Private Sub tbFineTune17_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune17.Scroll
    lblFineTune17.Text = tbFineTune17.Value
  End Sub
  Private Sub tbFineTune18_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune18.Scroll
    lblFineTune18.Text = tbFineTune18.Value
  End Sub
  Private Sub tbFineTune19_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune19.Scroll
    lblFineTune19.Text = tbFineTune19.Value
  End Sub
  Private Sub tbFineTune20_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune20.Scroll
    lblFineTune20.Text = tbFineTune20.Value
  End Sub
  Private Sub tbFineTune21_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune21.Scroll
    lblFineTune21.Text = tbFineTune21.Value
  End Sub
  Private Sub tbFineTune22_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune22.Scroll
    lblFineTune22.Text = tbFineTune22.Value
  End Sub
  Private Sub tbFineTune23_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune23.Scroll
    lblFineTune23.Text = tbFineTune23.Value
  End Sub
  Private Sub tbFineTune24_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune24.Scroll
    lblFineTune24.Text = tbFineTune24.Value
  End Sub
  Private Sub tbFineTune25_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune25.Scroll
    lblFineTune25.Text = tbFineTune25.Value
  End Sub
  Private Sub tbFineTune26_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune26.Scroll
    lblFineTune26.Text = tbFineTune26.Value
  End Sub
  Private Sub tbFineTune27_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune27.Scroll
    lblFineTune27.Text = tbFineTune27.Value
  End Sub
  Private Sub tbFineTune28_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune28.Scroll
    lblFineTune28.Text = tbFineTune28.Value
  End Sub
  Private Sub tbFineTune29_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune29.Scroll
    lblFineTune29.Text = tbFineTune29.Value
  End Sub
  Private Sub tbFineTune30_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune30.Scroll
    lblFineTune30.Text = tbFineTune30.Value
  End Sub
  Private Sub tbFineTune31_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFineTune31.Scroll
    lblFineTune31.Text = tbFineTune31.Value
  End Sub



  '==================================================================================================================

  Private Sub pnlNCFadsr_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlNCFadsr.Paint
    Dim h As Integer = pnlNCFadsr.Height
    Dim w As Integer = pnlNCFadsr.Width
    Dim g As Graphics = e.Graphics
    Dim p As Pen = New Pen(Color.Green, 3)
    Dim v As Integer
    Dim c As Char

    With cbbNCFadsrA
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCFadsrD
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCFadsrS
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 3250 Then .Text = "3250"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCFadsrR
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCFadsrPKval
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 3250 Then .Text = "3250"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCFadsrMINval
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    Dim P0 As Point = New Point(0, h)
    Dim P1 As Point = New Point(w * 0.3 * ((16383 - Val(cbbNCFadsrA.Text)) / 16383), 0)
    Dim P2 As Point = New Point(P1.X + w * 0.3 * ((16383 - Val(cbbNCFadsrD.Text)) / 16383), ((Val(cbbNCFadsrPKval.Text) - Val(cbbNCFadsrS.Text)) / Val(cbbNCFadsrPKval.Text)) * h)
    '      Dim P3 As Point = New Point(P2.X + w * 0.1, ((3250 - Val(cbbNCFadsrS.Text)) / 3250) * h)
    Dim P3 As Point = New Point(P2.X + w * 0.1, ((Val(cbbNCFadsrPKval.Text) - Val(cbbNCFadsrS.Text)) / Val(cbbNCFadsrPKval.Text)) * h)
    Dim P4 As Point = New Point(P3.X + w * 0.3 * ((16383 - Val(cbbNCFadsrR.Text)) / 16383), h)

    p.Color = Color.ForestGreen
    g.DrawLine(p, P0, P1)  ' color is initialized to green

    p.Color = Color.Red
    g.DrawLine(p, P1, P2)

    p.Color = Color.Blue
    g.DrawLine(p, P2, P3)

    p.Color = Color.Black
    g.DrawLine(p, P3, P4)

  End Sub

  Private Sub cbbNCFadsrA_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrA.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrD_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrD.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrS_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrS.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrR_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrR.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrA_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrA.Validating
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrD_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrD.Validating
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrS_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrS.Validating
    FixNCFsus()
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrR_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrR.Validating
    pnlNCFadsr.Refresh()
  End Sub

  Private Sub FixNCFpeak()
    Dim n As Integer
    n = Val(cbbNCFadsrPKval.Text)
    If Val(cbbNCFadsrPKval.Text) > 3250 Then n = 3250
    If n < 0 Then n = 0
    cbbNCFadsrPKval.Text = n.ToString()
  End Sub
  Private Sub FixNCFsus()
    ' if cbbNCFadsrMINval or cbbNCFadsrPKval changes, check that sustain won't violate 3250 rule.
    Dim n, min, peak, sus As Integer
    peak = Val(cbbNCFadsrPKval.Text)
    min = Val(cbbNCFadsrMINval.Text)
    sus = Val(cbbNCFadsrS.Text)

    If sus > peak Then cbbNCFadsrS.Text = cbbNCFadsrPKval.Text ' make sure sus is not > peak

    n = min + Val(cbbNCFadsrS.Text)

    If n > 3250 Then cbbNCFadsrS.Text = (3250 - Val(cbbNCFadsrMINval.Text)).ToString()

  End Sub
  Private Sub cbbNCFadsrPKval_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrPKval.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrPKval_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrPKval.Validating
    FixNCFpeak()
    FixNCFsus()
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrMINval_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCFadsrMINval.TextChanged
    pnlNCFadsr.Refresh()
  End Sub
  Private Sub cbbNCFadsrMINval_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCFadsrMINval.Validating
    FixNCFpeak()
    FixNCFsus()
    pnlNCFadsr.Refresh()
  End Sub

  Private Sub pnlNCAadsr_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlNCAadsr.Paint
    Dim h As Integer = pnlNCAadsr.Height
    Dim w As Integer = pnlNCAadsr.Width
    Dim g As Graphics = e.Graphics
    Dim p As Pen = New Pen(Color.Blue, 3)
    Dim v As Integer
    Dim c As Char

    With cbbNCAadsrA
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCAadsrD
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCAadsrS
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbbNCAadsrR
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    Dim P0 As Point = New Point(0, h)
    Dim P1 As Point = New Point(w * 0.3 * ((16383 - Val(cbbNCAadsrA.Text)) / 16383), 0)
    Dim P2 As Point = New Point(P1.X + w * 0.3 * ((16383 - Val(cbbNCAadsrD.Text)) / 16383), ((16383 - Val(cbbNCAadsrS.Text)) / 16383) * h)
    Dim P3 As Point = New Point(P2.X + w * 0.1, ((16383 - Val(cbbNCAadsrS.Text)) / 16383) * h)
    Dim P4 As Point = New Point(P3.X + w * 0.3 * ((16383 - Val(cbbNCAadsrR.Text)) / 16383), h)

    p.Color = Color.ForestGreen
    g.DrawLine(p, P0, P1)

    p.Color = Color.Red
    g.DrawLine(p, P1, P2)

    p.Color = Color.Blue
    g.DrawLine(p, P2, P3)

    p.Color = Color.Black
    g.DrawLine(p, P3, P4)
  End Sub
  Private Sub cbbNCAadsrA_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCAadsrA.TextChanged
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrD_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCAadsrD.TextChanged
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrS_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCAadsrS.TextChanged
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrR_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbbNCAadsrR.TextChanged
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrA_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCAadsrA.Validating
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrD_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCAadsrD.Validating
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrS_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCAadsrS.Validating
    pnlNCAadsr.Refresh()
  End Sub
  Private Sub cbbNCAadsrR_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbbNCAadsrR.Validating
    pnlNCAadsr.Refresh()
  End Sub


  Private Sub SendPatch()
    Dim tmp As Double
    Dim q As Integer

    'connect, actually, open the serial port
    Connect()


    'MIDI CHANNEL
    sendtty(&H0, &H0, nudMIDI_CHANNEL.Value - 1)



    ' NCO level  Values stored in page 01 of sysex address space
    sendtty(&H1, &H0, (tb_a0_0_310.Value) And &H7F)
    sendtty(&H1, &H1, (tb_a0_0_311.Value) And &H7F)
    sendtty(&H1, &H2, (tb_a0_0_312.Value) And &H7F)
    sendtty(&H1, &H3, (tb_a0_0_313.Value) And &H7F)
    sendtty(&H1, &H4, (tb_a0_0_314.Value) And &H7F)
    sendtty(&H1, &H5, (tb_a0_0_315.Value) And &H7F)
    sendtty(&H1, &H6, (tb_a0_0_316.Value) And &H7F)
    sendtty(&H1, &H7, (tb_a0_0_317.Value) And &H7F)
    sendtty(&H1, &H8, (tb_a0_0_318.Value) And &H7F)
    sendtty(&H1, &H9, (tb_a0_0_319.Value) And &H7F)
    sendtty(&H1, &HA, (tb_a0_0_3110.Value) And &H7F)
    sendtty(&H1, &HB, (tb_a0_0_3111.Value) And &H7F)
    sendtty(&H1, &HC, (tb_a0_0_3112.Value) And &H7F)
    sendtty(&H1, &HD, (tb_a0_0_3113.Value) And &H7F)
    sendtty(&H1, &HE, (tb_a0_0_3114.Value) And &H7F)
    sendtty(&H1, &HF, (tb_a0_0_3115.Value) And &H7F)
    sendtty(&H1, &H10, (tb_a0_0_3116.Value) And &H7F)
    sendtty(&H1, &H11, (tb_a0_0_3117.Value) And &H7F)
    sendtty(&H1, &H12, (tb_a0_0_3118.Value) And &H7F)
    sendtty(&H1, &H13, (tb_a0_0_3119.Value) And &H7F)
    sendtty(&H1, &H14, (tb_a0_0_3120.Value) And &H7F)
    sendtty(&H1, &H15, (tb_a0_0_3121.Value) And &H7F)
    sendtty(&H1, &H16, (tb_a0_0_3122.Value) And &H7F)
    sendtty(&H1, &H17, (tb_a0_0_3123.Value) And &H7F)
    sendtty(&H1, &H18, (tb_a0_0_3124.Value) And &H7F)
    sendtty(&H1, &H19, (tb_a0_0_3125.Value) And &H7F)
    sendtty(&H1, &H1A, (tb_a0_0_3126.Value) And &H7F)
    sendtty(&H1, &H1B, (tb_a0_0_3127.Value) And &H7F)
    sendtty(&H1, &H1C, (tb_a0_0_3128.Value) And &H7F)
    sendtty(&H1, &H1D, (tb_a0_0_3129.Value) And &H7F)
    sendtty(&H1, &H1E, (tb_a0_0_3130.Value) And &H7F)
    sendtty(&H1, &H1F, (tb_a0_0_3131.Value) And &H7F)

    sendtty(&H1, &H20, (tb_a0_32_630.Value) And &H7F)
    sendtty(&H1, &H21, (tb_a0_32_631.Value) And &H7F)
    sendtty(&H1, &H22, (tb_a0_32_632.Value) And &H7F)
    sendtty(&H1, &H23, (tb_a0_32_633.Value) And &H7F)
    sendtty(&H1, &H24, (tb_a0_32_634.Value) And &H7F)
    sendtty(&H1, &H25, (tb_a0_32_635.Value) And &H7F)
    sendtty(&H1, &H26, (tb_a0_32_636.Value) And &H7F)
    sendtty(&H1, &H27, (tb_a0_32_637.Value) And &H7F)
    sendtty(&H1, &H28, (tb_a0_32_638.Value) And &H7F)
    sendtty(&H1, &H29, (tb_a0_32_639.Value) And &H7F)
    sendtty(&H1, &H2A, (tb_a0_32_6310.Value) And &H7F)
    sendtty(&H1, &H2B, (tb_a0_32_6311.Value) And &H7F)
    sendtty(&H1, &H2C, (tb_a0_32_6312.Value) And &H7F)
    sendtty(&H1, &H2D, (tb_a0_32_6313.Value) And &H7F)
    sendtty(&H1, &H2E, (tb_a0_32_6314.Value) And &H7F)
    sendtty(&H1, &H2F, (tb_a0_32_6315.Value) And &H7F)
    sendtty(&H1, &H30, (tb_a0_32_6316.Value) And &H7F)
    sendtty(&H1, &H31, (tb_a0_32_6317.Value) And &H7F)
    sendtty(&H1, &H32, (tb_a0_32_6318.Value) And &H7F)
    sendtty(&H1, &H33, (tb_a0_32_6319.Value) And &H7F)
    sendtty(&H1, &H34, (tb_a0_32_6320.Value) And &H7F)
    sendtty(&H1, &H35, (tb_a0_32_6321.Value) And &H7F)
    sendtty(&H1, &H36, (tb_a0_32_6322.Value) And &H7F)
    sendtty(&H1, &H37, (tb_a0_32_6323.Value) And &H7F)
    sendtty(&H1, &H38, (tb_a0_32_6324.Value) And &H7F)
    sendtty(&H1, &H39, (tb_a0_32_6325.Value) And &H7F)
    sendtty(&H1, &H3A, (tb_a0_32_6326.Value) And &H7F)
    sendtty(&H1, &H3B, (tb_a0_32_6327.Value) And &H7F)
    sendtty(&H1, &H3C, (tb_a0_32_6328.Value) And &H7F)
    sendtty(&H1, &H3D, (tb_a0_32_6329.Value) And &H7F)
    sendtty(&H1, &H3E, (tb_a0_32_6330.Value) And &H7F)
    sendtty(&H1, &H3F, (tb_a0_32_6331.Value) And &H7F)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    sendtty(&H2, &H0, (tb_a0_0_310.Value >> 7) And &H7F)
    sendtty(&H2, &H1, (tb_a0_0_311.Value >> 7) And &H7F)
    sendtty(&H2, &H2, (tb_a0_0_312.Value >> 7) And &H7F)
    sendtty(&H2, &H3, (tb_a0_0_313.Value >> 7) And &H7F)
    sendtty(&H2, &H4, (tb_a0_0_314.Value >> 7) And &H7F)
    sendtty(&H2, &H5, (tb_a0_0_315.Value >> 7) And &H7F)
    sendtty(&H2, &H6, (tb_a0_0_316.Value >> 7) And &H7F)
    sendtty(&H2, &H7, (tb_a0_0_317.Value >> 7) And &H7F)
    sendtty(&H2, &H8, (tb_a0_0_318.Value >> 7) And &H7F)
    sendtty(&H2, &H9, (tb_a0_0_319.Value >> 7) And &H7F)
    sendtty(&H2, &HA, (tb_a0_0_3110.Value >> 7) And &H7F)
    sendtty(&H2, &HB, (tb_a0_0_3111.Value >> 7) And &H7F)
    sendtty(&H2, &HC, (tb_a0_0_3112.Value >> 7) And &H7F)
    sendtty(&H2, &HD, (tb_a0_0_3113.Value >> 7) And &H7F)
    sendtty(&H2, &HE, (tb_a0_0_3114.Value >> 7) And &H7F)
    sendtty(&H2, &HF, (tb_a0_0_3115.Value >> 7) And &H7F)
    sendtty(&H2, &H10, (tb_a0_0_3116.Value >> 7) And &H7F)
    sendtty(&H2, &H11, (tb_a0_0_3117.Value >> 7) And &H7F)
    sendtty(&H2, &H12, (tb_a0_0_3118.Value >> 7) And &H7F)
    sendtty(&H2, &H13, (tb_a0_0_3119.Value >> 7) And &H7F)
    sendtty(&H2, &H14, (tb_a0_0_3120.Value >> 7) And &H7F)
    sendtty(&H2, &H15, (tb_a0_0_3121.Value >> 7) And &H7F)
    sendtty(&H2, &H16, (tb_a0_0_3122.Value >> 7) And &H7F)
    sendtty(&H2, &H17, (tb_a0_0_3123.Value >> 7) And &H7F)
    sendtty(&H2, &H18, (tb_a0_0_3124.Value >> 7) And &H7F)
    sendtty(&H2, &H19, (tb_a0_0_3125.Value >> 7) And &H7F)
    sendtty(&H2, &H1A, (tb_a0_0_3126.Value >> 7) And &H7F)
    sendtty(&H2, &H1B, (tb_a0_0_3127.Value >> 7) And &H7F)
    sendtty(&H2, &H1C, (tb_a0_0_3128.Value >> 7) And &H7F)
    sendtty(&H2, &H1D, (tb_a0_0_3129.Value >> 7) And &H7F)
    sendtty(&H2, &H1E, (tb_a0_0_3130.Value >> 7) And &H7F)
    sendtty(&H2, &H1F, (tb_a0_0_3131.Value >> 7) And &H7F)

    sendtty(&H2, &H20, (tb_a0_32_630.Value >> 7) And &H7F)
    sendtty(&H2, &H21, (tb_a0_32_631.Value >> 7) And &H7F)
    sendtty(&H2, &H22, (tb_a0_32_632.Value >> 7) And &H7F)
    sendtty(&H2, &H23, (tb_a0_32_633.Value >> 7) And &H7F)
    sendtty(&H2, &H24, (tb_a0_32_634.Value >> 7) And &H7F)
    sendtty(&H2, &H25, (tb_a0_32_635.Value >> 7) And &H7F)
    sendtty(&H2, &H26, (tb_a0_32_636.Value >> 7) And &H7F)
    sendtty(&H2, &H27, (tb_a0_32_637.Value >> 7) And &H7F)
    sendtty(&H2, &H28, (tb_a0_32_638.Value >> 7) And &H7F)
    sendtty(&H2, &H29, (tb_a0_32_639.Value >> 7) And &H7F)
    sendtty(&H2, &H2A, (tb_a0_32_6310.Value >> 7) And &H7F)
    sendtty(&H2, &H2B, (tb_a0_32_6311.Value >> 7) And &H7F)
    sendtty(&H2, &H2C, (tb_a0_32_6312.Value >> 7) And &H7F)
    sendtty(&H2, &H2D, (tb_a0_32_6313.Value >> 7) And &H7F)
    sendtty(&H2, &H2E, (tb_a0_32_6314.Value >> 7) And &H7F)
    sendtty(&H2, &H2F, (tb_a0_32_6315.Value >> 7) And &H7F)
    sendtty(&H2, &H30, (tb_a0_32_6316.Value >> 7) And &H7F)
    sendtty(&H2, &H31, (tb_a0_32_6317.Value >> 7) And &H7F)
    sendtty(&H2, &H32, (tb_a0_32_6318.Value >> 7) And &H7F)
    sendtty(&H2, &H33, (tb_a0_32_6319.Value >> 7) And &H7F)
    sendtty(&H2, &H34, (tb_a0_32_6320.Value >> 7) And &H7F)
    sendtty(&H2, &H35, (tb_a0_32_6321.Value >> 7) And &H7F)
    sendtty(&H2, &H36, (tb_a0_32_6322.Value >> 7) And &H7F)
    sendtty(&H2, &H37, (tb_a0_32_6323.Value >> 7) And &H7F)
    sendtty(&H2, &H38, (tb_a0_32_6324.Value >> 7) And &H7F)
    sendtty(&H2, &H39, (tb_a0_32_6325.Value >> 7) And &H7F)
    sendtty(&H2, &H3A, (tb_a0_32_6326.Value >> 7) And &H7F)
    sendtty(&H2, &H3B, (tb_a0_32_6327.Value >> 7) And &H7F)
    sendtty(&H2, &H3C, (tb_a0_32_6328.Value >> 7) And &H7F)
    sendtty(&H2, &H3D, (tb_a0_32_6329.Value >> 7) And &H7F)
    sendtty(&H2, &H3E, (tb_a0_32_6330.Value >> 7) And &H7F)
    sendtty(&H2, &H3F, (tb_a0_32_6331.Value >> 7) And &H7F)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    sendtty(&H3, &H0, (tb_a0_0_310.Value >> 14) And &HF)
    sendtty(&H3, &H1, (tb_a0_0_311.Value >> 14) And &HF)
    sendtty(&H3, &H2, (tb_a0_0_312.Value >> 14) And &HF)
    sendtty(&H3, &H3, (tb_a0_0_313.Value >> 14) And &HF)
    sendtty(&H3, &H4, (tb_a0_0_314.Value >> 14) And &HF)
    sendtty(&H3, &H5, (tb_a0_0_315.Value >> 14) And &HF)
    sendtty(&H3, &H6, (tb_a0_0_316.Value >> 14) And &HF)
    sendtty(&H3, &H7, (tb_a0_0_317.Value >> 14) And &HF)
    sendtty(&H3, &H8, (tb_a0_0_318.Value >> 14) And &HF)
    sendtty(&H3, &H9, (tb_a0_0_319.Value >> 14) And &HF)
    sendtty(&H3, &HA, (tb_a0_0_3110.Value >> 14) And &HF)
    sendtty(&H3, &HB, (tb_a0_0_3111.Value >> 14) And &HF)
    sendtty(&H3, &HC, (tb_a0_0_3112.Value >> 14) And &HF)
    sendtty(&H3, &HD, (tb_a0_0_3113.Value >> 14) And &HF)
    sendtty(&H3, &HE, (tb_a0_0_3114.Value >> 14) And &HF)
    sendtty(&H3, &HF, (tb_a0_0_3115.Value >> 14) And &HF)
    sendtty(&H3, &H10, (tb_a0_0_3116.Value >> 14) And &HF)
    sendtty(&H3, &H11, (tb_a0_0_3117.Value >> 14) And &HF)
    sendtty(&H3, &H12, (tb_a0_0_3118.Value >> 14) And &HF)
    sendtty(&H3, &H13, (tb_a0_0_3119.Value >> 14) And &HF)
    sendtty(&H3, &H14, (tb_a0_0_3120.Value >> 14) And &HF)
    sendtty(&H3, &H15, (tb_a0_0_3121.Value >> 14) And &HF)
    sendtty(&H3, &H16, (tb_a0_0_3122.Value >> 14) And &HF)
    sendtty(&H3, &H17, (tb_a0_0_3123.Value >> 14) And &HF)
    sendtty(&H3, &H18, (tb_a0_0_3124.Value >> 14) And &HF)
    sendtty(&H3, &H19, (tb_a0_0_3125.Value >> 14) And &HF)
    sendtty(&H3, &H1A, (tb_a0_0_3126.Value >> 14) And &HF)
    sendtty(&H3, &H1B, (tb_a0_0_3127.Value >> 14) And &HF)
    sendtty(&H3, &H1C, (tb_a0_0_3128.Value >> 14) And &HF)
    sendtty(&H3, &H1D, (tb_a0_0_3129.Value >> 14) And &HF)
    sendtty(&H3, &H1E, (tb_a0_0_3130.Value >> 14) And &HF)
    sendtty(&H3, &H1F, (tb_a0_0_3131.Value >> 14) And &HF)

    sendtty(&H3, &H20, (tb_a0_32_630.Value >> 14) And &HF)
    sendtty(&H3, &H21, (tb_a0_32_631.Value >> 14) And &HF)
    sendtty(&H3, &H22, (tb_a0_32_632.Value >> 14) And &HF)
    sendtty(&H3, &H23, (tb_a0_32_633.Value >> 14) And &HF)
    sendtty(&H3, &H24, (tb_a0_32_634.Value >> 14) And &HF)
    sendtty(&H3, &H25, (tb_a0_32_635.Value >> 14) And &HF)
    sendtty(&H3, &H26, (tb_a0_32_636.Value >> 14) And &HF)
    sendtty(&H3, &H27, (tb_a0_32_637.Value >> 14) And &HF)
    sendtty(&H3, &H28, (tb_a0_32_638.Value >> 14) And &HF)
    sendtty(&H3, &H29, (tb_a0_32_639.Value >> 14) And &HF)
    sendtty(&H3, &H2A, (tb_a0_32_6310.Value >> 14) And &HF)
    sendtty(&H3, &H2B, (tb_a0_32_6311.Value >> 14) And &HF)
    sendtty(&H3, &H2C, (tb_a0_32_6312.Value >> 14) And &HF)
    sendtty(&H3, &H2D, (tb_a0_32_6313.Value >> 14) And &HF)
    sendtty(&H3, &H2E, (tb_a0_32_6314.Value >> 14) And &HF)
    sendtty(&H3, &H2F, (tb_a0_32_6315.Value >> 14) And &HF)
    sendtty(&H3, &H30, (tb_a0_32_6316.Value >> 14) And &HF)
    sendtty(&H3, &H31, (tb_a0_32_6317.Value >> 14) And &HF)
    sendtty(&H3, &H32, (tb_a0_32_6318.Value >> 14) And &HF)
    sendtty(&H3, &H33, (tb_a0_32_6319.Value >> 14) And &HF)
    sendtty(&H3, &H34, (tb_a0_32_6320.Value >> 14) And &HF)
    sendtty(&H3, &H35, (tb_a0_32_6321.Value >> 14) And &HF)
    sendtty(&H3, &H36, (tb_a0_32_6322.Value >> 14) And &HF)
    sendtty(&H3, &H37, (tb_a0_32_6323.Value >> 14) And &HF)
    sendtty(&H3, &H38, (tb_a0_32_6324.Value >> 14) And &HF)
    sendtty(&H3, &H39, (tb_a0_32_6325.Value >> 14) And &HF)
    sendtty(&H3, &H3A, (tb_a0_32_6326.Value >> 14) And &HF)
    sendtty(&H3, &H3B, (tb_a0_32_6327.Value >> 14) And &HF)
    sendtty(&H3, &H3C, (tb_a0_32_6328.Value >> 14) And &HF)
    sendtty(&H3, &H3D, (tb_a0_32_6329.Value >> 14) And &HF)
    sendtty(&H3, &H3E, (tb_a0_32_6330.Value >> 14) And &HF)
    sendtty(&H3, &H3F, (tb_a0_32_6331.Value >> 14) And &HF)





    ' disconnect, actually, close the serial port
    While serialPort.BytesToWrite > 0
      status.Text = serialPort.BytesToWrite.ToString
      status.Refresh()
    End While
    'status.Text = ""
    Disconnect()
  End Sub
  Function hi(ByVal word As Integer)   ' return high 7 bits of a 14 bit word
    Dim n As Integer
    n = word And &H3FFF
    hi = ((n And &H3F80) / 128)
  End Function
  Function lo(ByVal word As Integer)   ' return low 7 bits of a 14 bit word
    Dim n As Integer
    n = word And &H3FFF
    lo = (n And &H7F)
  End Function
  Sub sendtty(ByVal addrMSB As Integer, ByVal addrLSB As Integer, ByVal datum As Integer)
    Dim outstr As String
    outstr = header & Chr(addrMSB) & Chr(addrLSB) & Chr(datum) & Chr(&HF7)
    serialPort.Write(outstr)
  End Sub

  Private Sub btnSAVE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSAVE.Click
    With SaveFileDialog1
      .Title = "Save Patch"
      If lblPatchName.Text <> "PATCH: ----------------------------------------" Then
        .FileName = Mid(lblPatchName.Text, 8)
      End If
      .ShowDialog()
    End With
  End Sub

  Private Sub SaveFileDialog1_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
    Dim F As System.IO.Stream
    lblPatchName.Text = "PATCH: " & SaveFileDialog1.FileName
    F = SaveFileDialog1.OpenFile()

    ' coarse tuning offset                            FILE OFFSET
    'saveparm(CByte(Val(txtCrsTune0.Text)), F)         '00   1
    'saveparm(CByte(Val(txtCrsTune1.Text)), F)         '01   2
    'saveparm(CByte(Val(txtCrsTune2.Text)), F)         '02   3
    'saveparm(CByte(Val(txtCrsTune3.Text)), F)         '03   4
    saveparm(0, F)
    saveparm(0, F)
    saveparm(0, F)
    saveparm(0, F)


    ' fine tune  Note adding 4095 is to force the 14 bit value to be >= 0.  See load code, 4095 is subtracted
    saveparm(CByte(hi(tbFineTune0.Value + 4095)), F)  '04   5
    saveparm(CByte(lo(tbFineTune0.Value + 4095)), F)  '05 6
    saveparm(CByte(hi(tbFineTune1.Value + 4095)), F)  '06 7
    saveparm(CByte(lo(tbFineTune1.Value + 4095)), F)  '07 8
    saveparm(CByte(hi(tbFineTune2.Value + 4095)), F)  '08 9
    saveparm(CByte(lo(tbFineTune2.Value + 4095)), F)  '09 10
    saveparm(CByte(hi(tbFineTune3.Value + 4095)), F)  '0A 11
    saveparm(CByte(lo(tbFineTune3.Value + 4095)), F)  '0B 12

    ' global transpose
    saveparm(CByte(Val(cbbTRANSPOSE.Text)), F)        '0C 13

    ' amplifier
    ' obsolete
    ' saveparm(CByte(Val(cbbAMPLIFIER.Text)), F)
    ' we save a zero here to be compatible with files created by previous versions
    saveparm(CByte(0), F)                             '0D 14

    ' NCO level              
    saveparm(CByte(hi(tb_a0_0_310.Value)), F)              '0E 15
    saveparm(CByte(lo(tb_a0_0_310.Value)), F)              '0F 16
    saveparm(CByte(hi(tb_a0_0_311.Value)), F)              '10 17
    saveparm(CByte(lo(tb_a0_0_311.Value)), F)              '11 18
    saveparm(CByte(hi(tb_a0_0_313.Value)), F)              '12 19
    saveparm(CByte(lo(tb_a0_0_313.Value)), F)              '13 20
    saveparm(CByte(hi(tb_a0_0_312.Value)), F)              '14 21
    saveparm(CByte(lo(tb_a0_0_312.Value)), F)              '15 22

    ' portamento time
    saveparm(CByte(hi(tbPortTime0.Value)), F)         '16 23
    saveparm(CByte(lo(tbPortTime0.Value)), F)         '17 24
    saveparm(CByte(hi(tbPortTime1.Value)), F)         '18 25
    saveparm(CByte(lo(tbPortTime1.Value)), F)         '19 26
    saveparm(CByte(hi(tbPortTime2.Value)), F)         '1A 27
    saveparm(CByte(lo(tbPortTime2.Value)), F)         '1B 28
    saveparm(CByte(hi(tbPortTime3.Value)), F)         '1C 29
    saveparm(CByte(lo(tbPortTime3.Value)), F)         '1D 30

    ''''''' NCF ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCF ADSR A:
    saveparm(CByte(hi(Val(cbbNCFadsrA.Text))), F)     '1E 31
    saveparm(CByte(lo(Val(cbbNCFadsrA.Text))), F)     '1F 32

    ' NCF ADSR D:
    saveparm(CByte(hi(Val(cbbNCFadsrD.Text))), F)     '20 33
    saveparm(CByte(lo(Val(cbbNCFadsrD.Text))), F)     '21 34

    ' NCF ADSR S:
    saveparm(CByte(hi(Val(cbbNCFadsrS.Text))), F)     '22 35
    saveparm(CByte(lo(Val(cbbNCFadsrS.Text))), F)     '23 36

    ' NCF ADSR R:
    saveparm(CByte(hi(Val(cbbNCFadsrR.Text))), F)     '24 37
    saveparm(CByte(lo(Val(cbbNCFadsrR.Text))), F)     '25 38

    ' NCF ADSR PEAK VALUE (CB2 maximum [0x19,0x32]):
    saveparm(CByte(hi(Val(cbbNCFadsrPKval.Text))), F) '26 39
    saveparm(CByte(lo(Val(cbbNCFadsrPKval.Text))), F) '27 40

    ' NCF MINIMUM VALUE: this value is added to the ADSR output value.
    saveparm(CByte(hi(Val(cbbNCFadsrMINval.Text))), F) '28 41
    saveparm(CByte(lo(Val(cbbNCFadsrMINval.Text))), F) '29 42

    ' NCF Peak modulation source routing
    saveparm(CByte(cbbNCFadsrPKmodSRC.SelectedIndex), F) '2A 43

    ' NCF Sustain modulation source routine
    saveparm(CByte(cbbNCFadsrSUSmodSRC.SelectedIndex), F) '2B 44


    ''''''' NCA ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCA ADSR A:
    saveparm(CByte(hi(Val(cbbNCAadsrA.Text))), F)    '2C 45
    saveparm(CByte(lo(Val(cbbNCAadsrA.Text))), F)    '2D 46

    ' NCA ADSR D:
    saveparm(CByte(hi(Val(cbbNCAadsrD.Text))), F)    '2E 47
    saveparm(CByte(lo(Val(cbbNCAadsrD.Text))), F)    '2F 48

    ' NCA ADSR S:
    saveparm(CByte(hi(Val(cbbNCAadsrS.Text))), F)    '30 49
    saveparm(CByte(lo(Val(cbbNCAadsrS.Text))), F)    '31 50

    ' NCA ADSR R:
    saveparm(CByte(hi(Val(cbbNCAadsrR.Text))), F)    '32 51
    saveparm(CByte(lo(Val(cbbNCAadsrR.Text))), F)    '33 52

    ' NCA Peak modulation source routing
    saveparm(CByte(cbbNCAadsrPKmodSRC.SelectedIndex), F)  '34 53
    ' NCA Sustain modulation source routine
    saveparm(CByte(cbbNCAadsrSUSmodSRC.SelectedIndex), F) '35 54

    ' noise modulation levels: 36 - 3D
    saveparm(CByte(hi(tb_a0_32_630.Value)), F)     '36 55
    saveparm(CByte(lo(tb_a0_32_630.Value)), F)     '37 56
    saveparm(CByte(hi(tb_a0_32_631.Value)), F)     '38 57
    saveparm(CByte(lo(tb_a0_32_631.Value)), F)     '39 58
    saveparm(CByte(hi(tb_a0_32_632.Value)), F)     '3A 59
    saveparm(CByte(lo(tb_a0_32_632.Value)), F)     '3B 60 
    saveparm(CByte(hi(tb_a0_32_633.Value)), F)     '3C 61
    saveparm(CByte(lo(tb_a0_32_633.Value)), F)     '3D 62

    ' filter Q
    Dim tmp As Double
    Dim q As Integer
    tmp = 1.0 / (tbFiltQ.Value / 10.0)
    q = tmp * &H1FFF
    saveparm(CByte(hi(q)), F)                     '42 67 
    saveparm(CByte(lo(q)), F)                     '43 68

    ' DAC Window
    saveparm(CByte(Val(cbbDACwindow.Text)), F)    '44 69

    F.Close()

  End Sub
  Sub saveparm(ByVal b As Byte, ByRef f As System.IO.Stream)
    Dim buf(1) As Byte
    buf(0) = b
    f.Write(buf, 0, 1)
  End Sub

  Private Sub OpenFileDialog1_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
    Dim h, l As Integer
    Dim F As System.IO.Stream
    lblPatchName.Text = "PATCH: " & OpenFileDialog1.FileName
    F = OpenFileDialog1.OpenFile()

    ' coarse tuning offset
    'txtCrsTune0.Text = F.ReadByte().ToString()        '1
    'txtCrsTune1.Text = F.ReadByte().ToString()        '2
    'txtCrsTune2.Text = F.ReadByte().ToString()        '3
    'txtCrsTune3.Text = F.ReadByte().ToString()        '4
    F.ReadByte()
    F.ReadByte()
    F.ReadByte()
    F.ReadByte()

    ' fine tune
    h = F.ReadByte() : l = F.ReadByte() : tbFineTune0.Value = (h * 128 + l) - 4095  '5,6
    h = F.ReadByte() : l = F.ReadByte() : tbFineTune1.Value = (h * 128 + l) - 4095  '7,8
    h = F.ReadByte() : l = F.ReadByte() : tbFineTune2.Value = (h * 128 + l) - 4095  '9,10
    h = F.ReadByte() : l = F.ReadByte() : tbFineTune3.Value = (h * 128 + l) - 4095  '11,12
    lblFineTune0.Text = tbFineTune0.Value.ToString()
    lblFineTune1.Text = tbFineTune1.Value.ToString()
    lblFineTune2.Text = tbFineTune2.Value.ToString()
    lblFineTune3.Text = tbFineTune3.Value.ToString()

    ' global transpose
    cbbTRANSPOSE.Text = F.ReadByte().ToString()      '13

    ' amplifier
    ' obsolete
    ' cbbAMPLIFIER.Text = F.ReadByte().ToString()
    ' Stay compatible with files created by older versions, read a byte, but don't use it.
    F.ReadByte()          '14

    ' NCO level
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_0_310.Value = h * 128 + l         '15,16
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_0_311.Value = h * 128 + l         '17,18
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_0_313.Value = h * 128 + l         '19,20
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_0_312.Value = h * 128 + l         '21,22
    lblLev0.Text = tb_a0_0_310.Value.ToString
    lblLev1.Text = tb_a0_0_311.Value.ToString
    lblLev2.Text = tb_a0_0_313.Value.ToString
    lblLev3.Text = tb_a0_0_312.Value.ToString

    ' portamento time
    h = F.ReadByte() : l = F.ReadByte() : tbPortTime0.Value = h * 128 + l    '23,24
    h = F.ReadByte() : l = F.ReadByte() : tbPortTime1.Value = h * 128 + l    '25,26
    h = F.ReadByte() : l = F.ReadByte() : tbPortTime2.Value = h * 128 + l    '27,28
    h = F.ReadByte() : l = F.ReadByte() : tbPortTime3.Value = h * 128 + l    '29,30
    lblPortTime0.Text = tbPortTime0.Value.ToString
    lblPortTime1.Text = tbPortTime1.Value.ToString
    lblPortTime2.Text = tbPortTime2.Value.ToString
    lblPortTime3.Text = tbPortTime3.Value.ToString

    ''''''' NCF ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCF ADSR A:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrA.Text = (h * 128 + l).ToString   '31,32

    ' NCF ADSR D:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrD.Text = (h * 128 + l).ToString   '33,34

    ' NCF ADSR S:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrS.Text = (h * 128 + l).ToString   '35,36

    ' NCF ADSR R:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrR.Text = (h * 128 + l).ToString   '37,38

    ' NCF ADSR PEAK VALUE (CB2 maximum [0x19,0x32]):
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrPKval.Text = (h * 128 + l).ToString   '39,40

    ' NCF MINIMUM VALUE: this value is added to the ADSR output value.
    h = F.ReadByte() : l = F.ReadByte() : cbbNCFadsrMINval.Text = (h * 128 + l).ToString   '41,42

    ' NCF Peak modulation source routing
    cbbNCFadsrPKmodSRC.SelectedIndex = F.ReadByte()   '43

    ' NCF Sustain modulation source routine
    cbbNCFadsrSUSmodSRC.SelectedIndex = F.ReadByte()   '44

    ''''''' NCA ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCA ADSR A:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCAadsrA.Text = (h * 128 + l).ToString   '45,46

    ' NCA ADSR D:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCAadsrD.Text = (h * 128 + l).ToString   '47,48

    ' NCA ADSR S:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCAadsrS.Text = (h * 128 + l).ToString   '49,50

    ' NCA ADSR R:
    h = F.ReadByte() : l = F.ReadByte() : cbbNCAadsrR.Text = (h * 128 + l).ToString   '51,52

    ' NCA Peak modulation source routing
    cbbNCAadsrPKmodSRC.SelectedIndex = F.ReadByte()  '53
    ' NCA Sustain modulation source routine
    cbbNCAadsrSUSmodSRC.SelectedIndex = F.ReadByte()  ' 54

    ' noise modulation levels: 36 - 3D
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_32_630.Value = h * 128 + l  '55,56
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_32_631.Value = h * 128 + l  '57,58
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_32_632.Value = h * 128 + l  '59,60
    h = F.ReadByte() : l = F.ReadByte() : tb_a0_32_633.Value = h * 128 + l  '61,62
    lblNoiseMod0.Text = tb_a0_32_630.Value.ToString
    lblNoiseMod1.Text = tb_a0_32_631.Value.ToString
    lblNoiseMod2.Text = tb_a0_32_632.Value.ToString
    lblNoiseMod3.Text = tb_a0_32_633.Value.ToString

    pnlNCFadsr.Refresh()
    pnlNCAadsr.Refresh()

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Here starts GateMan-II specific parameters.
    ' Try block allows us to load most of the patch from an older file.
    ' GateMan-I will ignore the additional values.

    ' Filter Q track bar
    h = F.ReadByte() : l = F.ReadByte()                   '67,68
    If h = -1 And l = -1 Then h = 63 : l = 127
    tbFiltQ.Value = 10 * (8191 / (h * 128 + l))
    lblQval.Text = Format(tbFiltQ.Value / 10.0, "##.0")

    ' DAC window
    cbbDACwindow.Text = F.ReadByte().ToString         '69
    If cbbDACwindow.Text = "-1" Then cbbDACwindow.Text = "0"


    F.Close()

  End Sub

  Private Sub btnLOAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLOAD.Click
    OpenFileDialog1.ShowDialog()
  End Sub

  Private Sub btnHELP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHELP.Click
    dlgHelp.Show()
  End Sub

  Private Sub GateMan_I_Patch_Editor_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    With SaveFileDialog1
      .Title = "Save Patch"
      .ShowDialog()
    End With
  End Sub

  Private Sub tbFiltQ_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbFiltQ.Scroll
    lblQval.Text = Format(tbFiltQ.Value / 10.0, "##.0")
  End Sub

  Private Sub btnSequential_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)


  End Sub

  Private Sub btnReciprocals_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
  End Sub

  Private Sub btnSetAllTo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    lblNoiseMod0.Text = tb_a0_32_630.Value.ToString()
    lblNoiseMod1.Text = tb_a0_32_631.Value.ToString()
    lblNoiseMod2.Text = tb_a0_32_632.Value.ToString()
    lblNoiseMod3.Text = tb_a0_32_633.Value.ToString()
    lblNoiseMod4.Text = tb_a0_32_634.Value.ToString()
    lblNoiseMod5.Text = tb_a0_32_635.Value.ToString()
    lblNoiseMod6.Text = tb_a0_32_636.Value.ToString()
    lblNoiseMod7.Text = tb_a0_32_637.Value.ToString()
    lblNoiseMod8.Text = tb_a0_32_638.Value.ToString()
    lblNoiseMod9.Text = tb_a0_32_639.Value.ToString()

    lblNoiseMod10.Text = tb_a0_32_6310.Value.ToString()
    lblNoiseMod11.Text = tb_a0_32_6311.Value.ToString()
    lblNoiseMod12.Text = tb_a0_32_6312.Value.ToString()
    lblNoiseMod13.Text = tb_a0_32_6313.Value.ToString()
    lblNoiseMod14.Text = tb_a0_32_6314.Value.ToString()
    lblNoiseMod15.Text = tb_a0_32_6315.Value.ToString()
    lblNoiseMod16.Text = tb_a0_32_6316.Value.ToString()
    lblNoiseMod17.Text = tb_a0_32_6317.Value.ToString()
    lblNoiseMod18.Text = tb_a0_32_6318.Value.ToString()
    lblNoiseMod19.Text = tb_a0_32_6319.Value.ToString()

    lblNoiseMod20.Text = tb_a0_32_6320.Value.ToString()
    lblNoiseMod21.Text = tb_a0_32_6321.Value.ToString()
    lblNoiseMod22.Text = tb_a0_32_6322.Value.ToString()
    lblNoiseMod23.Text = tb_a0_32_6323.Value.ToString()
    lblNoiseMod24.Text = tb_a0_32_6324.Value.ToString()
    lblNoiseMod25.Text = tb_a0_32_6325.Value.ToString()
    lblNoiseMod26.Text = tb_a0_32_6326.Value.ToString()
    lblNoiseMod27.Text = tb_a0_32_6327.Value.ToString()
    lblNoiseMod28.Text = tb_a0_32_6328.Value.ToString()
    lblNoiseMod29.Text = tb_a0_32_6329.Value.ToString()

    lblNoiseMod30.Text = tb_a0_32_6330.Value.ToString()
    lblNoiseMod31.Text = tb_a0_32_6331.Value.ToString()
  End Sub


  Private Sub btnPortamentoLinear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPortamentoLinear.Click
    Dim h, l As Integer
    Dim reverse As Integer

    h = nudPortamentoLinearHigh.Value
    l = nudPortamentoLinearLow.Value

    If cbPortamentoReverse.Checked Then
      reverse = 1
    Else
      reverse = 0
    End If

    tbPortTime0.Value = (h - l) * Math.Abs(31 * reverse - 0) / 31 + l
    tbPortTime1.Value = (h - l) * Math.Abs(31 * reverse - 1) / 31 + l
    tbPortTime2.Value = (h - l) * Math.Abs(31 * reverse - 2) / 31 + l
    tbPortTime3.Value = (h - l) * Math.Abs(31 * reverse - 3) / 31 + l
    tbPortTime4.Value = (h - l) * Math.Abs(31 * reverse - 4) / 31 + l
    tbPortTime5.Value = (h - l) * Math.Abs(31 * reverse - 5) / 31 + l
    tbPortTime6.Value = (h - l) * Math.Abs(31 * reverse - 6) / 31 + l
    tbPortTime7.Value = (h - l) * Math.Abs(31 * reverse - 7) / 31 + l
    tbPortTime8.Value = (h - l) * Math.Abs(31 * reverse - 8) / 31 + l
    tbPortTime9.Value = (h - l) * Math.Abs(31 * reverse - 9) / 31 + l

    tbPortTime10.Value = (h - l) * Math.Abs(31 * reverse - 10) / 31 + l
    tbPortTime11.Value = (h - l) * Math.Abs(31 * reverse - 11) / 31 + l
    tbPortTime12.Value = (h - l) * Math.Abs(31 * reverse - 12) / 31 + l
    tbPortTime13.Value = (h - l) * Math.Abs(31 * reverse - 13) / 31 + l
    tbPortTime14.Value = (h - l) * Math.Abs(31 * reverse - 14) / 31 + l
    tbPortTime15.Value = (h - l) * Math.Abs(31 * reverse - 15) / 31 + l
    tbPortTime16.Value = (h - l) * Math.Abs(31 * reverse - 16) / 31 + l
    tbPortTime17.Value = (h - l) * Math.Abs(31 * reverse - 17) / 31 + l
    tbPortTime18.Value = (h - l) * Math.Abs(31 * reverse - 18) / 31 + l
    tbPortTime19.Value = (h - l) * Math.Abs(31 * reverse - 19) / 31 + l

    tbPortTime20.Value = (h - l) * Math.Abs(31 * reverse - 20) / 31 + l
    tbPortTime21.Value = (h - l) * Math.Abs(31 * reverse - 21) / 31 + l
    tbPortTime22.Value = (h - l) * Math.Abs(31 * reverse - 22) / 31 + l
    tbPortTime23.Value = (h - l) * Math.Abs(31 * reverse - 23) / 31 + l
    tbPortTime24.Value = (h - l) * Math.Abs(31 * reverse - 24) / 31 + l
    tbPortTime25.Value = (h - l) * Math.Abs(31 * reverse - 25) / 31 + l
    tbPortTime26.Value = (h - l) * Math.Abs(31 * reverse - 26) / 31 + l
    tbPortTime27.Value = (h - l) * Math.Abs(31 * reverse - 27) / 31 + l
    tbPortTime28.Value = (h - l) * Math.Abs(31 * reverse - 28) / 31 + l
    tbPortTime29.Value = (h - l) * Math.Abs(31 * reverse - 29) / 31 + l

    tbPortTime30.Value = (h - l) * Math.Abs(31 * reverse - 30) / 31 + l
    tbPortTime31.Value = (h - l) * Math.Abs(31 * reverse - 31) / 31 + l

  End Sub

  Private Sub btnSave_a0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave_a0.Click
    Dim writer As StreamWriter
    writer = New StreamWriter("a0.txt")

    writer.Write(tb_a0_0_310.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_311.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_312.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_313.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_314.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_315.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_316.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_317.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_318.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_319.Value.ToString & vbCrLf)

    writer.Write(tb_a0_0_3110.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3111.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3112.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3113.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3114.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3115.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3116.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3117.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3118.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3119.Value.ToString & vbCrLf)

    writer.Write(tb_a0_0_3120.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3121.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3122.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3123.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3124.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3125.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3126.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3127.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3128.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3129.Value.ToString & vbCrLf)

    writer.Write(tb_a0_0_3130.Value.ToString & vbCrLf)
    writer.Write(tb_a0_0_3131.Value.ToString & vbCrLf)
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    writer.Write(tb_a0_32_630.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_631.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_632.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_633.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_634.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_635.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_636.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_637.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_638.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_639.Value.ToString & vbCrLf)

    writer.Write(tb_a0_32_6310.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6311.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6312.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6313.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6314.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6315.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6316.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6317.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6318.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6319.Value.ToString & vbCrLf)

    writer.Write(tb_a0_32_6320.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6321.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6322.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6323.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6324.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6325.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6326.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6327.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6328.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6329.Value.ToString & vbCrLf)

    writer.Write(tb_a0_32_6330.Value.ToString & vbCrLf)
    writer.Write(tb_a0_32_6331.Value.ToString & vbCrLf)

    writer.Close()
  End Sub

  Private Sub btn_make_linear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_make_linear.Click
    Dim i As Integer
    Dim inc As Integer
    Dim v As Integer
    Dim writer As StreamWriter

    v = 3000
    inc = (Val(txt_a0_max.Text) - v) / 60

    writer = New StreamWriter("a0.txt")
    For i = 0 To 60
      If v > 131055 Then v = 131055
      writer.WriteLine(v.ToString())
      v = v + inc
      inc = inc - 1
    Next

    For i = 61 To 63
      writer.WriteLine("0")
    Next

    writer.Close()

    read_a0_file()

  End Sub
End Class
